$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_top.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_ctl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_fth.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_knl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_dmp.v

-f $ENV_CSTR_DIR_PRJ/source/xkcalcnel/fetcher/calc_fth_top_inc.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_top_inc.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_top_inc.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_top_inc.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_top_inc.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/dumper/calc_dmp_top_inc.f

$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_top.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_ctl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_fth.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_knl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_dmp.v

$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_top.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_ctl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_fth.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_knl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_dmp.v

-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/fetcher/calc_fth_top_lib.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_top_lib.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/substractor/calc_sub_top_lib.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/multiplier/calc_mul_top_lib.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/divider/calc_div_top_lib.f
-f $ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/dumper/calc_dmp_top_lib.f

$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_top.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_ctl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_fth.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_knl.v
$ENV_CSTR_DIR_PRJ/source/xkcalc/kernel/adder/calc_add_dmp.v

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : runListPack.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : a script-based pack list
    #
#-------------------------------------------------------------------------------


#*** MAIN BODY *****************************************************************
    cd ../
        TAR=database.tar
       #printf "update $TAR..."; rm -rf ./$TAR ; time tar -czf $TAR check document include library reference_model script simulation "source" synthesis
       #printf "update $TAR..."; rm -rf ./$TAR ; time tar -czf $TAR reference_model
       #printf "update $TAR..."; rm -rf ./$TAR ; time tar -czf $TAR check include library script simulation/rtl/rtl_calc_add_knl simulation/rtl/script "source" synthesis
        printf "update $TAR..."; rm -rf ./$TAR ; time tar -czf $TAR check                                       \
                                                                    include                                     \
                                                                    library                                     \
                                                                    script                                      \
                                                                    simulation/*/*/sub-testbench                \
                                                                    simulation/*/*/check_data/dut_setting.vh    \
                                                                    simulation/*/*/makefile                     \
                                                                    simulation/*/*/*.f                          \
                                                                    simulation/*/*/*.v                          \
                                                                    simulation/*/script                         \
                                                                   "source"                                     \
                                                                    synthesis
    cd - > /dev/null
    echo ""

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : lib2db.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : convert lib files to db files
    #
#-------------------------------------------------------------------------------

#*** PARAMETER *****************************************************************
    # usage
    CSTR_USAGE="[information from lib2db.sh] usage: ./lib2db.sh (dc|lc) <lib directory> [<corner>]"

    # sanity check
    if [ $# -ne 2 -a $# -ne 3 ]
    then
        echo "[error from lib2db.sh] wrong parameter number $#"
        echo $CSTR_USAGE
        exit 1
    fi
    if [ $1 != "dc" -a $1 != "lc" ]
    then
        echo "[error from lib2db.sh] wrong convertion tool $1, should be dc (Design Compiler) or lc (Library Compiler)"
        echo $CSTR_USAGE
        exit 1
    fi

    # location of libs
    CSTR_TOOL=$1
    CSTR_DIR=$2
    if [ $# -eq 3 ]
    then
        CSTR_CONNER=$3
    else
        CSTR_CONNER=ss_0p90v_0p90v_m40c
    fi

    # name of temperary tcl
    CSTR_TCL=lib2db.tcl.$$


#*** MAIN BODY *****************************************************************
    # generate script
    rm -f $CSTR_TCL
    if [ $CSTR_TOOL == "dc" ]
    then
        echo "enable_write_lib_mode" > $CSTR_TCL
    fi
    for datItm in $(ls $CSTR_DIR)
    do
        if [ -d $CSTR_DIR/$datItm ]
        then
            if [ -f $CSTR_DIR/$datItm/${datItm}_${CSTR_CONNER}.lib ]
            then
                echo "read_lib $CSTR_DIR/$datItm/${datItm}_${CSTR_CONNER}.lib" >> $CSTR_TCL
                echo "write_lib -format db ${datItm}_${CSTR_CONNER} -output $CSTR_DIR/$datItm/${datItm}_${CSTR_CONNER}.db" >> $CSTR_TCL
            else
                echo "$datItm/${datItm}_${CSTR_CONNER}.lib does not exist!"
            fi
        else
            echo "$datItm is not a directory!"
        fi
    done

    # convert
    if [ $CSTR_TOOL == "dc" ]
    then
        dc_shell-xg-t -f $CSTR_TCL | tee -i lib2db.log
    else
        lc_shell      -f $CSTR_TCL | tee -i lib2db.log
    fi

    # remove the temperary tcl
    rm $CSTR_TCL

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : runListCheck.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : a script-based check list
    #
#-------------------------------------------------------------------------------

#*** SUB FUNCTION **************************************************************
    # run
    run() {
        timeBgn=$(date +%s)
        echo "running $1..." | tee -a dump/check.log
        chmod a+x ./tool_script/???_$1/$1.sh
        ./tool_script/???_$1/$1.sh >> dump/check.log
        timeEnd=$(date +%s)
        printf "    elapsed %d s\n" $((timeEnd - timeBgn))
    }


#*** MAIN BODY *****************************************************************
    # item
    mkdir -p dump; rm -f dump/check.log
    run "checkFileHeader"
    run "checkDefineAndUndef"
    run "checkModuleDeclaration"
    run "checkExtraComma"
    run "checkParamInputOutputRegAndWireDeclaration"
    run "checkAssignment"
    run "checkBitOperation"
    run "checkExpressionInSquareBracket"
    run "checkDigitPrefix"
    run "checkUnreferencedVariable"
    run "checkLineLength"

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : updateStatus.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : update status
    #
#-------------------------------------------------------------------------------

#*** PARAMETER *****************************************************************
CSTR_TYP_ALL=(
    c
    lst
    m
    mk
    pl
    prj
    sgdc
    sh
    template
    tcl
    v
    vh
)
CSTR_DIR_ALL=(
    check
    document
    include
    library
    reference_model
    script
    simulation
    source
    synthesis
)


#*** MAIN BODY *****************************************************************
mkdir -p dump
echo "running checkFileHeader..." > dump/status.log
for strDir in ${CSTR_DIR_ALL[*]}
do
    for strTyp in ${CSTR_TYP_ALL[*]}
    do
        if [ -d "../$strDir" ]
        then
            for strItm in $(find "../$strDir" -name "*.$strTyp")
            do
                #flgWrittenByMe=$(egrep "Author.*(Huang Leilei|Liu Chang|Liu Xun|Hou Bingjing)" $strItm)
                flgWrittenByMe=1
                egrep -q 'skip checkFileHeader' $strItm
                if [ $? -ne 0 -a "$flgWrittenByMe" != "" ]
                then
                    egrep -q '^[ #/]+Status         : ' $strItm
                    if [ $? -eq 0 ]
                    then
                        egrep '^[ #/]+Status         : ' $strItm | sed "s#.*: \(.*\)#    \1\t$strItm#" >> dump/status.log
                    else
                        printf "    no status\t$strItm\n" >> dump/status.log
                    fi
                fi
            done
        fi
    done
done

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : regression.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : run regression
    #
#-------------------------------------------------------------------------------

#*** SUB FUNCTION **************************************************************
    # showParameter
    showParameter() {
        echo "***********************************************************************************"
        echo "*"
        echo "*   ENV_FLAG_SHOW_CFG          (show configurations or not                         ) = $ENV_FLAG_SHOW_CFG      "
        echo "*   ENV_FLAG_BACKUP            (backup regression results or not                   ) = $ENV_FLAG_BACKUP        "
        echo "*   ENV_NUMB_JOB               (number of jobs running parallelly                  ) = $ENV_NUMB_JOB           "
        echo "*   EDA_CSTR_TOOL              (EDA tool (synopsys, cadence)                       ) = $EDA_CSTR_TOOL          "
        echo "*   T_V_CSTR_DIR               (directory of test vectors                          ) = $T_V_CSTR_DIR           "
        echo "*   T_V_CSTR_PATTERN           (name/pattern of the targeted test vectors          ) = $T_V_CSTR_PATTERN       "
        echo "*   SIM_KNOB_DBG               (enable debug codes or not                          ) = $SIM_KNOB_DBG           "
        echo "*   SIM_CSTR_LEVEL_STOP        (stop all/current/no case(s) when any error reported) = $SIM_CSTR_LEVEL_STOP    "
        echo "*   SIM_DATA_SEED              (random seed                                        ) = $SIM_DATA_SEED          "
        echo "*   SIM_KNOB_WAVEFORM          (dump waveform or not                               ) = $SIM_KNOB_WAVEFORM      "
        echo "*   SIM_DATA_WAVEFORM_TIME     (time to dump shm                                   ) = $SIM_DATA_WAVEFORM_TIME "
        echo "*   SIM_CSTR_WAVEFORM_LEVEL    (dump level of shm                                  ) = $SIM_CSTR_WAVEFORM_LEVEL"
        echo "*   COV_FLAG                   (collect coverage or not                            ) = $COV_FLAG               "
        echo "*   COV_CSTR_TOP               (module to do coverage collection                   ) = $COV_CSTR_TOP           "
        echo "*"
        echo "***********************************************************************************"
    }

    # queryWaiveCondition
    queryWaiveCondition() {
        # do nothing
        flgSkp="None"
    }


#*** MAIN BODY *****************************************************************
#--- PREV ------------------------------
    # note down start time
    timeRegrBgn=$(date +%s)

    # arguement
    {
        ENV_FLAG_SHOW_CFG=$1
        ENV_FLAG_BACKUP=$2
        ENV_NUMB_JOB=$3
        EDA_CSTR_TOOL=$4
        T_V_CSTR_DIR=$5
        T_V_CSTR_PATTERN=$6
        SIM_KNOB_DBG=$7
        SIM_CSTR_LEVEL_STOP=$8
        SIM_DATA_SEED=$9
        SIM_KNOB_WAVEFORM=${10}
        SIM_DATA_WAVEFORM_TIME=${11}
        SIM_CSTR_WAVEFORM_LEVEL=${12}
        COV_FLAG=${13}
        COV_CSTR_TOP=${14}

        showParameter
    }

    # parameter
    SIM_CSTR_LOG="simul_data/run.log"
    SIM_CSTR_DIR_CHECK="check_data"
    SIM_CSTR_DIR_SIMUL="simul_data"
    SIM_CSTR_MARKER_ERROR="ERROR"
    REGR_CSTR_LOG_ERROR="error.log"
    REGR_CSTR_LOG_SKIP="skip.log"
    REGR_CSTR_DIR_SIMUL="simul_data_regr"

    # make directory
    mkdir -p $SIM_CSTR_DIR_CHECK
    mkdir -p $SIM_CSTR_DIR_SIMUL
    mkdir -p $REGR_CSTR_DIR_SIMUL
    strDirTb=$(basename `pwd`)
    for idx in $(seq 0 $((ENV_NUMB_JOB - 1)))
    do
        rm -rf  ../${strDirTb}_${idx}
        cp -r . ../${strDirTb}_${idx}
    done

    # find all test cases
    strDirTvAll=$(ls -v -d $T_V_CSTR_DIR/$T_V_CSTR_PATTERN)
    numTv=$(      ls -v -l $T_V_CSTR_DIR/$T_V_CSTR_PATTERN/dut_setting.vh | wc -l)

    # reset counter
    numRun=0
    numSkp=0
    numErr=0
    idxRun=0


#--- CORE ------------------------------
    # main loop
    for strDirTv in $strDirTvAll
    do
        # if it is a directory
        if [ -d $strDirTv ]
        then
            # note down start time
            timeTvBgn=$(date +%s)

            # log info of the current test case
            echo "discovered test case: [$strDirTv]"

            # update current number
            numRun=$((numRun + 1))

            # change directory
            cd ../${strDirTb}_${idxRun}

            # note down short_name
            strTvInShort=${strDirTv#$T_V_CSTR_DIR\/}
            strTvInShort=${strTvInShort/\//_}
            strTvInShortAll[$idxRun]=$strTvInShort

            # link dv files
            echo "  linking dv files ..."
            rm -rf ./$SIM_CSTR_DIR_CHECK/*
            strFileTvAll=$(ls -d $strDirTv/*)
            for strFileTv in $strFileTvAll
            do
                ln -f    $strFileTv $SIM_CSTR_DIR_CHECK/${strFileTv##*/}
                #ln -f -s $strFileTv $SIM_CSTR_DIR_CHECK/${strFileTv##*/}
            done

            # show configuration
            if [ $ENV_FLAG_SHOW_CFG -eq 1 ]
            then
                # do nothing here
                echo "" > /dev/null
            fi

            # queryWaiveCondition
            queryWaiveCondition

            # run
            if [ "$flgSkp" != "None" ]
            then
                # update skip number
                numSkp=$((numSkp + 1))

                # log skip info
                echo "  this case is skipped (skip reason: $flgSkp)!"
                echo "$strDirTv is skipped (skip reason: $flgSkp)!" >> ../$strDirTb/$REGR_CSTR_LOG_SKIP
            else
                # !!! a recompilation could be forced by touch dut_setting.vh,
                # !!! but one has to have the authority to do so.
                # !!! as a result, i directly use "make clean" here.
                #touch $SIM_CSTR_DIR_CHECK/dut_setting.vh
                make clean > /dev/null

                # run simulation
                echo "  running simulation... (enter q after press ctrl+c to exit)"
                if [ $COV_FLAG -eq 1 ]
                then
                    make cov                                                \
                        EDA_CSTR_TOOL=$EDA_CSTR_TOOL                        \
                        SIM_KNOB_DBG=$SIM_KNOB_DBG                          \
                        SIM_CSTR_LEVEL_STOP=$SIM_CSTR_LEVEL_STOP            \
                        SIM_DATA_SEED=$SIM_DATA_SEED                        \
                        SIM_KNOB_WAVEFORM=$SIM_KNOB_WAVEFORM                \
                        SIM_DATA_WAVEFORM_TIME=$SIM_DATA_WAVEFORM_TIME      \
                        SIM_CSTR_WAVEFORM_LEVEL=$SIM_CSTR_WAVEFORM_LEVEL    \
                        COV_CSTR_TOP=$COV_CSTR_TOP                          \
                    > /dev/null &
                else
                    make sim                                                \
                        EDA_CSTR_TOOL=$EDA_CSTR_TOOL                        \
                        SIM_KNOB_DBG=$SIM_KNOB_DBG                          \
                        SIM_CSTR_LEVEL_STOP=$SIM_CSTR_LEVEL_STOP            \
                        SIM_DATA_SEED=$SIM_DATA_SEED                        \
                        SIM_KNOB_WAVEFORM=$SIM_KNOB_WAVEFORM                \
                        SIM_DATA_WAVEFORM_TIME=$SIM_DATA_WAVEFORM_TIME      \
                        SIM_CSTR_WAVEFORM_LEVEL=$SIM_CSTR_WAVEFORM_LEVEL    \
                    > /dev/null &
                fi
            fi

            # block when parallel number reaches ENV_NUMB_JOB-1 or current number reaches total case number
            if [ $idxRun -eq $((ENV_NUMB_JOB - 1)) ] || [ $numRun -eq $numTv ]
            then
                # update run time
                while [ $(jobs | wc -l) -ne 0 ]
                do
                    timeEnd=$(date +%s)
                    printf "  delta time: %d min %d s; run time: %d min %d s (R/S/E/A=%d/%d/%d/%d)    \r"    \
                        $(((timeEnd-timeTvBgn  ) / 60                         ))                             \
                        $(((timeEnd-timeTvBgn  ) - (timeEnd-timeTvBgn  )/60*60))                             \
                        $(((timeEnd-timeRegrBgn) / 60                         ))                             \
                        $(((timeEnd-timeRegrBgn) - (timeEnd-timeRegrBgn)/60*60))                             \
                        $numRun                                                                              \
                        $numSkp                                                                              \
                        $numErr                                                                              \
                        $numTv
                    jobs > /dev/null    # I don't know why, but this line must be added
                    sleep 1
                done
                printf "                                                                            \r"

                # check result
                for idx in $(seq 0 $idxRun)
                do
                    # change direcory
                    cd ../${strDirTb}_${idx}
                    strTvInShort=${strTvInShortAll[$idx]}

                    # early terminate (fatal)
                    if [ $(cat $SIM_CSTR_LOG | grep '*E' | wc -l) -gt 0 ]
                    then
                        cat $SIM_CSTR_LOG | grep '*E'
                        exit
                    fi

                    # update error number
                    if [ $(cat $SIM_CSTR_LOG | grep $SIM_CSTR_MARKER_ERROR | wc -l) -gt 0 ]
                    then
                        numErr=$((numErr + 1))
                    fi

                    # log error info if exists
                    cat $SIM_CSTR_LOG                           \
                        | sed -n "/$SIM_CSTR_MARKER_ERROR/p"    \
                        | sed -n "s/^/$strTvInShort -> /p"      \
                        | tee -a ../$strDirTb/$REGR_CSTR_LOG_ERROR

                    # save simulation results
                    if [ $ENV_FLAG_BACKUP -eq 1 ]
                    then
                        echo "  saving simulation results..."
                        mv $SIM_CSTR_DIR_SIMUL ../$strDirTb/$REGR_CSTR_DIR_SIMUL/$DIR_SIMUL_${strTvInShort}
                        cp $SIM_CSTR_TOP.v     ../$strDirTb/$REGR_CSTR_DIR_SIMUL/$DIR_SIMUL_${strTvInShort}
                        mkdir -p $SIM_CSTR_DIR_SIMUL
                    fi
                done

                # note down run time
                timeEnd=$(date +%s)
                printf "  delta time: %d min %d s; run time: %d min %d s (R/S/E/A=%d/%d/%d/%d)    \n"    \
                    $(((timeEnd-timeTvBgn  ) / 60                         ))                             \
                    $(((timeEnd-timeTvBgn  ) - (timeEnd-timeTvBgn  )/60*60))                             \
                    $(((timeEnd-timeRegrBgn) / 60                         ))                             \
                    $(((timeEnd-timeRegrBgn) - (timeEnd-timeRegrBgn)/60*60))                             \
                    $numRun                                                                              \
                    $numSkp                                                                              \
                    $numErr                                                                              \
                    $numTv
                echo

                # early terminate (error)
                if [ $SIM_CSTR_LEVEL_STOP == "all" ]
                then
                    if [ $numErr -gt 0 ]
                        then
                        break
                    fi
                fi
            fi

            # update parallel counter
            if [ "$flgSkp" == "None" ]
            then
                idxRun=$(((idxRun + 1) % ENV_NUMB_JOB))
            fi
        fi
    done


#--- POST ------------------------------
    # display info
    {
        timeEnd=$(date +%s)

        showParameter

        echo "*"
        echo "*   REGRESSION FINISHED AT $(date)"
        if [ $numErr -gt 0 ]
        then
            echo "*                                                                                  "
            echo "*                                                         *********                "
            echo "*                                                      **           **             "
            echo "*         *                   *                      *               **            "
            echo "*          *                 *                     *                   *           "
            echo "*           *               *                     *                  ** *          "
            echo "*            *             *                     *         ***      *  * *         "
            echo "*             *           *                      *        *   *     *  * *         "
            echo "*              *         *                       *        *   *     *  *  *        "
            echo "*               *       *                        *        *   *      **   *        "
            echo "*                *     *                         *         ***            * ***    "
            echo "*                 *   *                           *                       *    *   "
            echo "*                  * *                            *     ***      *****     *   *   "
            echo "*                   *                             *    *   *    *    *     * **    "
            echo "*                  * *                            *   *    *     ****      **      "
            echo "*                 *   *                          *         *               *       "
            echo "*                *     *                        **       **                *       "
            echo "*               *       *                     **        *                  *       "
            echo "*              *         *                   *                             *       "
            echo "*             *           *                   *                            *       "
            echo "*            *             *                **                             *       "
            echo "*           *               *              *                               *       "
            echo "*          *                 *             *   **                          *       "
            echo "*         *                   *             ***  *                ***  **          "
            echo "*                                                *   * **    *    H L L            "
            echo "*                                                ***    ****   ***                 "
            echo "*                                                                                  "
        else
            echo "*                                                                                                            "
            echo "*                                                        ..***.....    .*.***..*.                            "
            echo "*                                                     .**.        *   *.          ..                         "
            echo "*                                   *               .*.           * .*              ..                       "
            echo "*                                  *               *.      *.     ***                 ..                     "
            echo "*                                 *                *       *  ..  **                   .*                    "
            echo "*                                *                 .*      *  ** .*           .*.......***.                  "
            echo "*                               *                    *     .. .  *.        .*.   .....    .                  "
            echo "*                              *              .*....***.   .* .          .**.**...   ..*.                    "
            echo "*                             *            .*.        ..*   * ..       .**..            .*                   "
            echo "*                            *            **             .  .* .  .                       *.                 "
            echo "*                           *            *.                  ...  .*    .       ..**.....  ..                "
            echo "*                          *           *                    *...***..    ..   .*.        **.*.               "
            echo "*                         *           *           .......        .....     .**          .*  **               "
            echo "*                        *           *        .**....**.           ...       ..        .*    *.              "
            echo "*       *               *            *      .*.    .*.              .         *       **..***.               "
            echo "*        *             *             *    ..      .*        .                 *      ***.                    "
            echo "*         *           *              *  .*.     ..         *                  *                              "
            echo "*          *         *               ..*.      ..        ... *                ..                             "
            echo "*           *       *                 .       ..      ..       **.            *          ..***HLL****.       "
            echo "*            *     *                         .*    .*.         ..**         *.      ..****..         .*.     "
            echo "*             *   *                          *   .*.           * *. *.      *    .*****.                     "
            echo "*              * *                           .  .*.            . .    ..   *   *..**.                        "
            echo "*               *                            *.*               ...      .***.*..*.                           "
            echo "*                                            *.               . *       **. *.                               "
            echo "*                                                            . *      *. .*                                  "
            echo "*                                                                                                            "
        fi
        echo "*     run time:        $(((timeEnd-timeRegrBgn) / 60)) min $(((timeEnd-timeRegrBgn) - (timeEnd-timeRegrBgn)/60*60)) s"
        echo "*     run/skp/err/all: $numRun / >>> $numSkp <<< / >>> $numErr <<< / $numTv"
        echo "*"
        echo "***********************************************************************************"
    }

    # remove run directories
    if [ $ENV_NUMB_JOB -ne 1 ]
    then
        for idx in $(seq 0 $((ENV_NUMB_JOB - 1)))
        do
            rm -rf ../${strDirTb}_${idx}
        done
    fi

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : checkModuleDeclaration.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : check module declaration (top)
    #
#-------------------------------------------------------------------------------

#*** PARAMETER *****************************************************************
CSTR_TYP_ALL=(
    v
)
CSTR_DIR_ALL=(
    library
    simulation
    source
)


#*** MAIN BODY *****************************************************************
for strDir in ${CSTR_DIR_ALL[*]}
do
    for strTyp in ${CSTR_TYP_ALL[*]}
    do
        if [ -d "../$strDir" ]
        then
            for strItm in $(find "../$strDir" -name "*.$strTyp")
            do
                #flgWrittenByMe=$(egrep "Author.*(Huang Leilei|Liu Chang|Liu Xun|Hou Bingjing)" $strItm)
                flgWrittenByMe=1
                if [ "$flgWrittenByMe" != "" ]
                then
                    ./tool_script/*/checkModuleDeclarationCore.pl $strItm
                fi
            done
        fi
    done
done

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : collect.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : collect simulation results
    #
#-------------------------------------------------------------------------------

#*** PARAMETER *****************************************************************
CSTR_DIR_ALL=(
    calc_add_knl
)
CSTR_DIR_DUMP=dump


#*** MAIN BODY *****************************************************************
rm -rf ./$CSTR_DIR_DUMP
mkdir    $CSTR_DIR_DUMP
for strDir in ${CSTR_DIR_ALL[*]}
do
    # generate
    cd ../../rtl_$strDir
    make clean_all
    make com_view EDA_CSTR_TOOL="cds"
    make com_view EDA_CSTR_TOOL="syn"
    make chk_view EDA_CSTR_TOOL="syn"
    make sim      EDA_CSTR_TOOL="cds"
    make sim      EDA_CSTR_TOOL="syn"
    cd -
    # collect
    mkdir -p                                          $CSTR_DIR_DUMP/rtl_$strDir/simul_data
    cp ../../rtl_$strDir/simul_data/com_ncverilog.log $CSTR_DIR_DUMP/rtl_$strDir/simul_data
    cp ../../rtl_$strDir/simul_data/com_vlogan.log    $CSTR_DIR_DUMP/rtl_$strDir/simul_data
    cp ../../rtl_$strDir/simul_data/chk_verdi.log     $CSTR_DIR_DUMP/rtl_$strDir/simul_data
    cp ../../rtl_$strDir/simul_data/sim_ncverilog.log $CSTR_DIR_DUMP/rtl_$strDir/simul_data
    cp ../../rtl_$strDir/simul_data/sim_vcs.log       $CSTR_DIR_DUMP/rtl_$strDir/simul_data
done

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : collect.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : collect synthesis results
    #
#-------------------------------------------------------------------------------

#*** PARAMETER *****************************************************************
CSTR_DIR_ALL=(
    calc_add_knl
)
CSTR_DIR_DUMP=dump


#*** MAIN BODY *****************************************************************
rm -rf ./$CSTR_DIR_DUMP
mkdir    $CSTR_DIR_DUMP
sed -i 's/#exit/exit/' ../top.tcl
for strDir in ${CSTR_DIR_ALL[*]}
do
    # generate
    cd ../../dc_$strDir
    make syn DATA_PRD_CLK=2.000
    make syn DATA_PRD_CLK=10.000
    make syn_view
    cd -
    # collect
    mkdir -p                                                                        $CSTR_DIR_DUMP/dc_$strDir/session_2.000/log
    cp ../../dc_$strDir/session_2.000/log/syn.log                                   $CSTR_DIR_DUMP/dc_$strDir/session_2.000/log
    mkdir -p                                                                        $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_check_design.rpt                $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_check_timing.rpt                $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_link.rpt                        $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_report_area_hierarchy.rpt       $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_report_clock_gating_ungated.rpt $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_report_power.rpt                $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    cp ../../dc_$strDir/session_2.000/rpt/${strDir}_report_timing.rpt               $CSTR_DIR_DUMP/dc_$strDir/session_2.000/rpt
    mkdir -p                                                                        $CSTR_DIR_DUMP/dc_$strDir/session_10.000/rpt
    cp ../../dc_$strDir/session_10.000/rpt/${strDir}_report_area_hierarchy.rpt      $CSTR_DIR_DUMP/dc_$strDir/session_10.000/rpt
done
sed -i 's/exit/#exit/' ../top.tcl

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : runListUpdate.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : a script-based update list
    #
#-------------------------------------------------------------------------------

#*** TOOL **********************************************************************
# run
    run() {
        CSTR_SCRIPT=$1
        CSTR_MODE=$2
        CSTR_PARAM=$3
        CSTR_SCRIPT_IN_SHORT=${CSTR_SCRIPT##*/}
        CSTR_SCRIPT_IN_SHORT=${CSTR_SCRIPT_IN_SHORT%%.*}
        if [ "$CSTR_MODE" == "skip" ]
        then
            echo "    SKIPPING $CSTR_SCRIPT_IN_SHORT..."
        else
            echo "    running $CSTR_SCRIPT_IN_SHORT..."
            chmod a+x $CSTR_SCRIPT
            if [ "$CSTR_MODE" == "quiet" ]
            then
                ./$CSTR_SCRIPT $CSTR_PARAM > /dev/null
            else
                ./$CSTR_SCRIPT $CSTR_PARAM
            fi
        fi
    }


#*** MAIN BODY *****************************************************************
# update auto-generated codes
    echo "updating codes..."
    cd ../include/script
        run "define2undef.sh" "r"
    cd - > /dev/null

# reformat
    echo "reformating..."
    cd .
        run "tool_script/???_dos2unix/dos2unix.sh"                       "r"
        run "tool_script/???_deleteTrailingBlank/deleteTrailingBlank.sh" "r"
    cd - > /dev/null

# grep markers
    mkdir -p dump
    echo "grepping markers..."
    echo "    grep TODO..."; grep "[/#%].*TODO" ../check ../include ../library ../reference_model ../script/tool_script ../simulation ../source ../synthesis -rn > dump/todo.log
    echo "    grep NOTE..."; grep "[/#%].*NOTE" ../check ../include ../library ../reference_model ../script/tool_script ../simulation ../source ../synthesis -rn > dump/note.log
    echo "    grep ??? ..."; grep "[/#%]\s*???" ../check ../include ../library ../reference_model ../script/tool_script ../simulation ../source ../synthesis -rn > dump/question.log
    echo "    grep !!! ..."; grep "[/#%].*!!!"  ../check ../include ../library ../reference_model ../script/tool_script ../simulation ../source ../synthesis -rn > dump/emphasis.log

# grep status
    echo "grepping status..."
    cd .
        run "tool_script/???_updateStatus/updateStatus.sh"    "r"
    cd - > /dev/null

# remove empty directories
    cd ../
        echo "removing empty directories..."
        dirEmpty=$(find . -type d -empty)
        while [ "$dirEmpty" != "" ]
        do
            for dirCur in $dirEmpty
            do
                echo "  $dirCur"
            done
            echo "  ---"
            rm -rf $dirEmpty
            dirEmpty=$(find . -type d -empty)
        done
    cd - > /dev/null

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : runXkcalc.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : perform regression run on xkcalc (core)
    #
#-------------------------------------------------------------------------------

#*** FUNCTION ******************************************************************
echoParameter() {
    echo "CSTR_DIR_VECT        :    $CSTR_DIR_VECT"
    echo "CSTR_INFO_VECT_ALL   :    ${CSTR_INFO_VECT_ALL[*]}"
    echo "FLAG_EARLY_TERMINATE :    $FLAG_EARLY_TERMINATE"
}


#*** PARAMETER *****************************************************************
#--- GLOBAL ----------------------------
CSTR_DIR_VECT="../../../pj_example_c_model/data/XKCALC"               #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
#   name         frame number    frame size x    frame size y    frame size z
CSTR_INFO_VECT_ALL=(
    "test_00"    3               16              32              8    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_01"    4               87              63              1    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_02"    7               48              13              4    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_03"    2               9               87              2    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_04"    1               51              45              6    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_05"    8               7               8               3    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_06"    10              27              35              7    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_07"    5               51              65              8    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_08"    9               48              36              7    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
    "test_09"    4               13              3               5    #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT
)
FLAG_EARLY_TERMINATE=1                                                #REVERT_THIS_ITEM_BEFORE_YOU_COMMIT


#--- LOCAL -----------------------------
CSTR_DUT="xkcalc"
CSTR_DIR_DUMP="dump"


#--- DERIVED ---------------------------
CSTR_LOG_RUN="$CSTR_DIR_DUMP/runs.log"
CSTR_LOG_JOB="$CSTR_DIR_DUMP/jobs.log"


#*** MAIN BODY *****************************************************************
#--- PREV ------------------------------
# prepare directory
mkdir -p $CSTR_DIR_DUMP
rm -rf $CSTR_DIR_DUMP/*

# echo parameter
echoParameter $*
echo ""

# note down the current time
timeBgnAll=$(date +%s)


#--- CORE ------------------------------
#--- LOOP VECTOR ---
flgErrAll=0
numVect=${#CSTR_INFO_VECT_ALL[*]}
cntVect=0
while [ $cntVect -lt $numVect ]
do
    # extract parameters
    CSTR_VECT=${CSTR_INFO_VECT_ALL[$cntVect]}; cntVect=$((cntVect + 1))
    NUMB_FRAME=${CSTR_INFO_VECT_ALL[$cntVect]}; cntVect=$((cntVect + 1))
    SIZE_FRAME_X=${CSTR_INFO_VECT_ALL[$cntVect]}; cntVect=$((cntVect + 1))
    SIZE_FRAME_Y=${CSTR_INFO_VECT_ALL[$cntVect]}; cntVect=$((cntVect + 1))
    SIZE_FRAME_Z=${CSTR_INFO_VECT_ALL[$cntVect]}; cntVect=$((cntVect + 1))

    # derive parameters
    CSTR_FILE_INP=$CSTR_DIR_VECT/$CSTR_VECT/$CSTR_VECT

    # log
    echo "processing $CSTR_VECT (N-X-Y-Z: ${NUMB_FRAME}-${SIZE_FRAME_X}-${SIZE_FRAME_Y}-${SIZE_FRAME_Z})..."

    # note down the current time
    timeBgnCur=$(date +%s)

    #--- LOOP SATURATION ---
    for flgSaturation in 0 1
    do
        # derive parameters
        CSTR_DIR_SUB=${CSTR_VECT}_flgSaturation${flgSaturation}
        CSTR_DIR_DUMP_FUL=$CSTR_DIR_DUMP/$CSTR_DIR_SUB
        CSTR_FILE_OUT=$CSTR_DIR_DUMP_FUL/$CSTR_DUT

        # make directory
        mkdir -p $CSTR_DIR_DUMP_FUL

        # log
        echo "    flgSaturation $flgSaturation launched ..."

        # run
        ./$CSTR_DUT                                      \
            --strFileCfg          $CSTR_DUT.cfg          \
            --strFileInp          $CSTR_FILE_INP.dat     \
            --strFileOut          $CSTR_FILE_OUT.dat     \
            --strPrefixDump       $CSTR_DIR_DUMP_FUL/    \
            --addFlgSaturation    $flgSaturation         \
            --subFlgSaturation    $flgSaturation         \
            --mulFlgSaturation    $flgSaturation         \
            --divFlgSaturation    $flgSaturation         \
            --numFrame            $NUMB_FRAME            \
            --sizFrameX           $SIZE_FRAME_X          \
            --sizFrameY           $SIZE_FRAME_Y          \
            --sizFrameZ           $SIZE_FRAME_Z          \
            --sizUnitZ            $SIZE_FRAME_Z          \
                                                         \
            --enmLoad             0                      \
            --sizUnitY            2                      \
            --sizUnitX            2                      \
                                                         \
            $*                                           \
        > $CSTR_FILE_OUT.log &
    done

    # wait
    numJob=1
    while [ $numJob -ne 0 ]
    do
        sleep 1
        timeEnd=$(date +%s)
        printf "    delta time: %d min %d s; run time: %d min %d s (jobs: %d)        \r"    \
            $(((timeEnd-timeBgnCur) / 60                        ))                          \
            $(((timeEnd-timeBgnCur) - (timeEnd-timeBgnCur)/60*60))                          \
            $(((timeEnd-timeBgnAll) / 60                        ))                          \
            $(((timeEnd-timeBgnAll) - (timeEnd-timeBgnAll)/60*60))                          \
            $(jobs | wc -l)
        jobs > $CSTR_LOG_JOB
        numJob=$(cat $CSTR_LOG_JOB | wc -l)
        grep 127 $CSTR_LOG_JOB
    done
    rm $CSTR_LOG_JOB
    timeEnd=$(date +%s)
    printf "    delta time: %d min %d s; run time: %d min %d s                   \n"    \
        $(((timeEnd-timeBgnCur) / 60                        ))                          \
        $(((timeEnd-timeBgnCur) - (timeEnd-timeBgnCur)/60*60))                          \
        $(((timeEnd-timeBgnAll) / 60                        ))                          \
        $(((timeEnd-timeBgnAll) - (timeEnd-timeBgnAll)/60*60))

    #--- LOOP SATURATION ---
    for flgSaturation in 0 1
    do
        # derive parameters
        CSTR_DIR_SUB=${CSTR_VECT}_flgSaturation${flgSaturation}
        CSTR_DIR_DUMP_FUL=$CSTR_DIR_DUMP/$CSTR_DIR_SUB
        CSTR_FILE_OUT=$CSTR_DIR_DUMP_FUL/$CSTR_DUT

        # check
        # get flgErr and set flgErrAll
        # for example
        # flgErr=$(diff -q XXX XXX)
        # if [ "$flgErr" != "" ]
        # then
        #     echo $flgErr
        #     flgErrAll=1
        # fi

        # calculate md5sum
        md5sum $CSTR_FILE_OUT.dat | tee -a $CSTR_LOG_RUN

        # collect result
        #...
    done

    # early termination
    if [ $FLAG_EARLY_TERMINATE -eq 1 -a $flgErrAll -eq 1 ]
    then
        break;
    fi

    # log
    echo ""
done


#--- POST ------------------------------
# echo error
if [ $flgErrAll -eq 1 ]
then
    echo ""
    echo "[error from $0] error exists!" >& 2
fi

# echo parameter
echoParameter $*

#!/bin/bash
#-------------------------------------------------------------------------------
    #
    #  Filename       : checkDefineAndUndef.sh
    #  Author         : Huang Leilei
    #  Status         : draft
    #  Created        : 2026-03-03
    #  Description    : check define and undefine
    #
#-------------------------------------------------------------------------------

#*** PARAMETER *****************************************************************
CSTR_TYP_ALL=(
    v
)
CSTR_DIR_ALL=(
    simulation
    source
)


#*** MAIN BODY *****************************************************************
for strDir in ${CSTR_DIR_ALL[*]}
do
    for strTyp in ${CSTR_TYP_ALL[*]}
    do
        if [ -d "../$strDir" ]
        then
            for strItm in $(find "../$strDir" -name "*.$strTyp")
            do
                # define
                CSTR_GREP=$(egrep '`include "define.*\.vh"' $strItm)
                NUMB_GREP=$(egrep '`include "define.*\.vh"' $strItm | wc -l)
                if [ $NUMB_GREP -ne 1 ]
                then
                    printf "    please check the include of \"define\" in $strItm\n"
                    continue;
                else
                    CSTR_LEVEL_DEFINE=${CSTR_GREP#*define}
                    if [ $CSTR_LEVEL_DEFINE == '.vh"' ]
                    then
                        continue;
                    fi
                fi
                # undef
                CSTR_GREP=$(egrep '`include "undef.*\.vh"' $strItm)
                NUMB_GREP=$(egrep '`include "undef.*\.vh"' $strItm | wc -l)
                if [ $NUMB_GREP -ne 1 ]
                then
                    printf "    please check the include of \"undef\" in $strItm\n"
                    continue;
                else
                    CSTR_LEVEL_UNDEF=${CSTR_GREP#*undef}
                fi
                # define and undef
                if [ "$CSTR_LEVEL_UNDEF" != "$CSTR_LEVEL_DEFINE" ]
                then
                    printf "    please check the include of \"define\" and \"undef\" in $strItm\n"
                fi
            done
        fi
    done
done
